package net.mcreator.puzzle_code.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.puzzle_code.world.inventory.HealthBlockGUINearReactMenu;
import net.mcreator.puzzle_code.procedures.NearReactDisplayOnProcedure;
import net.mcreator.puzzle_code.procedures.NearReactDisplayOffProcedure;
import net.mcreator.puzzle_code.network.HealthBlockGUINearReactButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class HealthBlockGUINearReactScreen extends AbstractContainerScreen<HealthBlockGUINearReactMenu> {
	private final static HashMap<String, Object> guistate = HealthBlockGUINearReactMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Button button_back;
	ImageButton imagebutton_change_button;

	public HealthBlockGUINearReactScreen(HealthBlockGUINearReactMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 125;
		this.imageHeight = 80;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("puzzle_code:textures/screens/health_block_gui_near_react.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		if (NearReactDisplayOnProcedure.execute(world, x, y, z)) {
			guiGraphics.blit(ResourceLocation.parse("puzzle_code:textures/screens/logic_true.png"), this.leftPos + 8, this.topPos + 18, 0, 0, 48, 20, 48, 20);
		}
		if (NearReactDisplayOffProcedure.execute(world, x, y, z)) {
			guiGraphics.blit(ResourceLocation.parse("puzzle_code:textures/screens/logic_false.png"), this.leftPos + 8, this.topPos + 18, 0, 0, 48, 20, 48, 20);
		}
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.health_block_gui_near_react.label_react_when_is_near"), 13, 5, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.health_block_gui_near_react.label_nbt_nearreact"), 8, 41, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		button_back = Button.builder(Component.translatable("gui.puzzle_code.health_block_gui_near_react.button_back"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new HealthBlockGUINearReactButtonMessage(0, x, y, z));
				HealthBlockGUINearReactButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 8, this.topPos + 54, 108, 20).build();
		guistate.put("button:button_back", button_back);
		this.addRenderableWidget(button_back);
		imagebutton_change_button = new ImageButton(this.leftPos + 98, this.topPos + 18, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/change_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/change_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new HealthBlockGUINearReactButtonMessage(1, x, y, z));
						HealthBlockGUINearReactButtonMessage.handleButtonAction(entity, 1, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_change_button", imagebutton_change_button);
		this.addRenderableWidget(imagebutton_change_button);
	}
}
